//+------------------------------------------------------------------+
//|                                                   Stochastic RSI |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  PaleVioletRed
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_style2  STYLE_DOT
#property indicator_level2  20
#property indicator_level1  80

//
//
//
//
//

extern int CCIPeriod                 = 14;
extern int CCIPrice                  =  5;
extern int StochasticKPeriod         = 14;
extern int StochasticSlowing         =  3;
extern int StochasticSlowingMaMethod =  5;
extern int StochasticDPeriod         =  3;
extern int StochasticDMaMethod       =  5;

//
//
//
//
//

double stochcci[];
double stochcciSignal[];
double cci[];
double stoch[];
double alphas[];
double cciprices[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,stochcci);
   SetIndexBuffer(1,stochcciSignal);
   SetIndexBuffer(2,cci);
   SetIndexBuffer(3,stoch);
   SetIndexBuffer(4,cciprices);
   

      //
      //
      //
      //
      //
      
      string smooth1 = getAverageName(StochasticSlowingMaMethod);
      string smooth2 = getAverageName(StochasticDMaMethod);
      
      //
      //
      //
      //
      //
      
   IndicatorShortName("Stochastic nonlag CCI ("+CCIPeriod+","+StochasticKPeriod+","+StochasticSlowing+","+smooth1+","+StochasticDPeriod+","+smooth2+")");
   return(0);
}
int deinit() { return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      cciprices[i]  = iNoLagMa(iMA(NULL,0,1,0,MODE_SMA,CCIPrice,i),CCIPeriod,alphas,0,i);
      double avg    = 0; for(k=0; k<CCIPeriod; k++) avg +=         cciprices[i+k];      avg /= CCIPeriod;
      double dev    = 0; for(k=0; k<CCIPeriod; k++) dev += MathAbs(cciprices[i+k]-avg); dev /= CCIPeriod;
      if (dev!=0)
      cci[i]            = (cciprices[i]-avg)/(0.015*dev);
      else  cci[i]      = 0;
      double min        = cci[ArrayMinimum(cci,StochasticKPeriod,i)];
      double max        = cci[ArrayMaximum(cci,StochasticKPeriod,i)];
      stoch[i]          = 0; if (min!=max) stoch[i] = 100.0*(cci[i]-min)/(max-min);
      stochcci[i]       = iCMAOnArray(stoch   ,stochcci      ,StochasticSlowing,StochasticSlowingMaMethod,i);
      stochcciSignal[i] = iCMAOnArray(stochcci,stochcciSignal,StochasticDPeriod,StochasticDMaMethod      ,i);
   }
   return(0);
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iCMAOnArray(double& source[], double& result[], int period, int method, int i)
{
   switch(method)
   {
      case 0: return(iSmaOnArray(source,period,i));
      case 1: return(iEmaOnArray(source,result,period,i));
      case 2: return(iSmmaOnArray(source,result,period,i));
      case 3: return(iLwmaOnArray(source,period,i));
      case 4: return(iTmaOnArray(source,period,i));
      case 5: return(iSineWMAOnArray(source,period,i));
      case 6: return(iVolumeWMAOnArray(source,period,i));
      case 7: return(iEPMAOnArray(source,period,i));
   }
   return(EMPTY_VALUE);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iSmaOnArray(double& array[], double period, int i)
{
   double sum = 0; 
   for(int k=0; k<period && (i+k)<Bars; k++) sum += array[i+k];  
   if (k!=0)
         return(sum/k);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iEmaOnArray(double& source[], double& result[], double period, int i)
{
   double alpha = 2.0 / (1.0+period);
          result[i] = result[i+1]+alpha*(source[i]-result[i+1]);
   return(result[i]);
}
//
//
//
//
//

double iSmmaOnArray(double& source[], double& result[], double period, int i)
{
   if (i>=(Bars-period))
   {
      double sum = 0; 
         for(int k=0; k<period && (i+k)<Bars; k++) sum += source[i+k];  
         if (k!=0)
               result[i] = sum/k;
         else  result[i] = EMPTY_VALUE;
   }      
   else   result[i] = (result[i+1]*(period-1)+source[i])/period;
   return(result[i]);
}

//
//
//
//
//

double iLwmaOnArray(double& array[], double period, int i)
{
   double sum  = 0;
   double sumw = 0;

   for(int k=0; k<period && (i+k)<Bars; k++)
   {
      double weight = period-k;
             sumw  += weight;
             sum   += weight*array[i+k];  
   }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iTmaOnArray(double& array[], double period, int i)
{
   double half = (period+1.0)/2.0;
   double sum  = 0;
   double sumw = 0;

   for(int k=0; k<period && (i+k)<Bars; k++)
   {
      double weight = k+1; if (weight > half) weight = period-k;
             sumw  += weight;
             sum   += weight*array[i+k];  
   }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

#define Pi 3.14159265358979323846
double iSineWMAOnArray(double& array[], int period, int i)
{
   double sum  = 0;
   double sumw = 0;
  
   for(int k=0; k<period && (i+k)<Bars; k++)
   { 
      double weight = MathSin(Pi*(k+1)/(period+1));
             sumw  += weight;
             sum   += weight*array[i+k]; 
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iVolumeWMAOnArray(double& array[], int period, int i)
{
   double sum  = 0;
   double sumw = 0;
  
   for(int k=0; k<period && (i+k)<Bars; k++)
   { 
      double weight = Volume[i+k];
             sumw  += weight;
             sum   += weight*array[i+k]; 
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iEPMAOnArray(double& array[], int period, int i)
{
   double weight = 2.0*period-1.0;
   double sum    = 0;
   double sumw   = 0;
  
   for(int k=0; k<period && (i+k)<Bars; k++)
   { 
       sumw   += weight;
       sum    += weight*array[i+k]; 
       weight -= 3;
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string methodNames[] = {"SMA","EMA","SMMA","LWMA","TriMA","SWMA","VWMA","EPMA"};
string getAverageName(int& method)
{
   method=MathMax(MathMin(method,7),0); return(methodNames[method]);
}

double values[][3];
double prices[][1];

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

//
//
//
//
//

double iNoLagMa(double price, int length, double &alphasArray[], int forValue, int i)
{
   if (ArrayRange(prices,0) != Bars) ArrayResize(prices,Bars);
            int r = Bars-i-1;  prices[r][forValue]=price;
   if (length<3 || r<3) return(prices[r][forValue]);
   
   //
   //
   //
   //
   //
   
   if (ArrayRange(values,0)<(forValue+1) || values[forValue][_length] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
      if (ArrayRange(values,0)<forValue+1) ArrayResize(values,forValue+1);

         values[forValue][_length] = length;
         values[forValue][_len]    = length*4 + Phase;  
         values[forValue][_weight] = 0;  
         ArrayResize(alphasArray,values[forValue][_len]);

         for (int k=0; k<values[forValue][_len]-1; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            alphasArray[k]             = g * beta;
            values[forValue][_weight] += alphasArray[k];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (values[forValue][_weight]>0)
   {
      int    len = values[forValue][_len];
      double sum = 0;
           for (k=0; k < len-1; k++) sum += alphasArray[k]*prices[r-k][forValue];      
           return( sum / values[forValue][_weight]);
   }
   else return(0);           
}